#ifndef _PIECE_VECTOR_H
#define _PIECE_VECTOR_H
#include "osl/piece.h"
#include "osl/misc/fixedCapacityVector.h"
#include <iosfwd>
namespace osl
{
  namespace container
  {
    class PieceVector : public FixedCapacityVector<Piece,Piece::SIZE>
    {
    public:
      /**
       * 駒の価値の小さい順に並び替える.
       * 成っているかに関わらず 歩香桂銀金角飛王
       */
      void sortByBasic();
      /**
       * 駒の価値の大きい順に並び替える. 成りを考慮.
       * 王龍馬...
       */
      void sortByPtype();
    };
    std::ostream& operator<<(std::ostream& os,const PieceVector&);
  } // namespace container
  using container::PieceVector;
} // namespace osl
#endif // _PIECE_VECTOR_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
